<template>
    <NuxtLayout :name="'dashboard'">
        <div class="flex justify-evenly container p-8">
            <div class="p-2 my-12 rounded-lg lg:w-1/2 xl:1/2 h-fit border-solid border-slate-300 border-2">
                <!-- <DynamicForm :fields="fields" :formTitle="formTitle" :customEvent="'addItem'" @on-additem="addItem"
                    :submitName="submitName" :onSubmit="onSubmit" /> -->
                <div class="p-2">
                    <h2 class="w-full text-center mb-4 text-xl font-semibold">
                        {{ formTitle }}
                    </h2>
                    <form @submit.prevent="onSubmit">
                        <label for="outcome" class="font-bold mb-2">Outcome</label>
                        <textarea class="w-full mt-2 border border-solid rounded-lg p-4 focus:outline-none focus:ring"
                            name="outcome" id="outcome" cols="30"
                            :class="isValidInput ? 'focus:border-blue-500 border-blue-500 ring-blue-400' : 'focus:border-red-500 border-red-500 ring-red-400'"
                            rows="5" v-model="outcomeList"></textarea>
                        <div class="flex mt-2">
                            <span v-for="outcome in formatedOutcome" class="bg-blue-300 py-1 px-2 rounded-md mr-2">
                                {{ `${outcome.key} (${outcome.value})` }}</span>
                        </div>
                        <button type="submit" :disabled="!isValidInput"
                            class="w-full py-2 px-4 mt-4 bg-blue-500 text-white rounded-lg hover:bg-blue-600 active:bg-blue-900">
                            <span v-if="isLoading">
                                <Icon name="eos-icons:bubble-loading" class="w-5 h-5" />
                                {{ submitName }}
                            </span>
                            <span v-else>
                                <Icon name="material-symbols:save" class="w-5 h-5" />
                                {{ submitName }}
                            </span>
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </NuxtLayout>
</template>
  
<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

export default {
    data() {
        return {
            formTitle: "Create Report",
            submitName: "Save",
            isLoading: false,
            fundingId: '',
            outcomeList: '',
            isValidInput: false,
        };
    },
    mounted() {
        this.fundingId = this.$route.params.funding_id as string;
        this.fetchData();
    },
    computed: {
        formatedOutcome() {
            let formatedList: { key: string, value: string }[] = [];
            let lists = this.outcomeList.split(';');

            lists.forEach(list => {
                let keyValue = list.split(':');
                // Ensure the key and value are present before pushing to formatedList
                if (keyValue.length === 2) {
                    let formattedItem = {
                        key: keyValue[0].trim(),   // Trim to remove leading/trailing whitespaces
                        value: keyValue[1].trim()
                    };
                    formatedList.push(formattedItem);
                }
            });

            return formatedList;
        }
    },
    watch: {
        outcomeList(newVal, oldVal) {
            // Do something when myValue changes
            this.isValidInput = this.validateInput(newVal);
            console.log(this.isValidInput);
        }
    },
    methods: {
        fetchData() {
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.get(`/funding/${this.fundingId}`,
                {
                    headers: {
                        'Accept': 'application/json',
                        'Authorization': `Bearer ${accessToken}`,
                    },
                })
                .then((response) => {
                    const data = response.data;
                    this.outcomeList = data.report;
                    console.log(data);
                    // this.form.title = data.title;
                    // this.form.description = data.description;
                    // this.status = data.status;
                    // this.formToField(response.data);
                })
                .catch((error) => {
                    console.log(error)
                })
        },
        onSubmit() {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;

            this.$api
                .post(`/funding/${this.fundingId}/report`,
                    { report: this.outcomeList },
                    {
                        headers: {
                            'Accept': 'application/json',
                            'Authorization': `Bearer ${accessToken}`,
                        },
                    }
                )
                .then((response) => {
                    console.log(response);
                    toastStore.showToast('success', "Data stored successfully");
                    this.$router.replace("/funding");
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        validateInput(input: string) {
            // Regular expression to match the desired format
            const regex = /^(\w+:\d+;)+$/;
            return regex.test(input);
        },
    },
};
</script>
  